package cv3;
 
import cv3.servis.BicycleVisitor;
 
public class Bicycle {
 
    public enum Color {
        Red("red", 1), Blue("blue", 12), Green("green", 123);
 
        private String name;
        private int code;
 
        private Color(String name, int code) {
            this.name = name;
            this.code = code;
        }
 
        public String getName() {
            return name;
        }
 
        public int getCode() {
            return code;
        }
    };
 
    // the Bicycle class has three fields
    public int cadence;
    public int gear;
    public int speed;
    public Color color;
 
    // the Bicycle class has one constructor
    public Bicycle(int startCadence, int startSpeed, int startGear, Color color) {
        gear = startGear;
        cadence = startCadence;
        speed = startSpeed;
        this.color = color;
    }
 
    // the Bicycle class has four methods
    public void setCadence(int newValue) {
        cadence = newValue;
    }
 
    public void setGear(int newValue) {
        gear = newValue;
    }
 
    public void applyBrake(int decrement) {
        speed -= decrement;
    }
 
    public void speedUp(int increment) {
        speed += increment;
    }
 
    public void printDescription() {
        System.out.println("\nBike is " + "in gear " + this.gear
                + " with a cadence of " + this.cadence +
                " and travelling at a speed of " + this.speed + ". ");
    }
 
    public void visit(BicycleVisitor servis) {
        servis.accept(this);
    }
 
}
