package cv3;
 
import cv3.holder.BicycleHolder;
import cv3.holder.MountainBikeHolder;
import cv3.holder.RoadBikeHolder;
import cv3.servis.BicycleVisitor;
import java.util.ArrayList;
import java.util.List;
 
public class Car implements BicycleVisitor {
    private final List<BicycleHolder> list = new ArrayList<BicycleHolder>(4);
 
    @Override
    public void accept(Bicycle b) {
        BicycleHolder bh = new BicycleHolder(b);
        addHolder(bh);
    }
 
    @Override
    public void accept(MountainBike b) {
        BicycleHolder bh = new MountainBikeHolder(b);
        addHolder(bh);
    }
 
    @Override
    public void accept(RoadBike b) {
        BicycleHolder bh = new RoadBikeHolder(b);
        addHolder(bh);
    }
 
    private void addHolder(BicycleHolder bicycleHolder) {
        if (list.size() < 4) {
            list.add(bicycleHolder);
        } else {
            throw new ArrayIndexOutOfBoundsException();
        }
    }
 
    public void print() {
        for (BicycleHolder bh : list) {
            System.out
                    .println(bh.getClass().getSimpleName() + " holding " + bh.getBicycle().getClass().getSimpleName());
        }
    }
}
